#!/usr/bin/perl

$TARGET_FILE = "gconv-modules";

#$arch = `uname -m` ;
#chomp($arch) ;


#if( $arch eq "x86_64")
if( "$ARGV[0]" eq "x86_64" )

{
	$TARGET_DIR  = "/usr/lib64/gconv";
}
else
{
	$TARGET_DIR  = "/usr/lib/gconv";
}


#---------------------------------------------------------
# Check privilege
#---------------------------------------------------------
if( $> != 0 )
{
	die( "You have to execute this program with root privilege. aborted.\n" );
}

#---------------------------------------------------------
# Open STDIN/STDOUT
#---------------------------------------------------------
open( TTYIN,  "/dev/tty")   || die "Cannot open tty!\n";
open( TTYOUT, "> /dev/tty") || die "Cannot open tty!\n";

print "Do you want to update gconv-modules cache?(y/n) = ";
$instring = <TTYIN>; chomp($instring);

if( $instring eq "Y" || $instring eq "y" )
{
	open( FD, '<', "${TARGET_DIR}/${TARGET_FILE}" ) or die( "${TARGET_DIR}/${TARGET_FILE}: $!\n" );
	my @lines = <FD>;
	close( FD );

	my @match = grep( /ARIB-STD-B24/, @lines );
	if( !@match )
	{
		if( ! -f "${TARGET_DIR}/${TARGET_FILE}.cache" )
		{
			die( "Can't find file:${TARGET_DIR}/${TARGET_FILE}.cache aborted.\n" );
		}
		if( ! -f "${TARGET_DIR}/${TARGET_FILE}")
		{
			die( "Can't find file:${TARGET_DIR}/${TARGET_FILE} aborted.\n" );
		}
		if( ! -f "${TARGET_DIR}/${TARGET_FILE}.arib" )
		{
			die( "Can't find file:${TARGET_DIR}/${TARGET_FILE}.arib aborted.\n" );
		}

		system( "/bin/mv  ${TARGET_DIR}/${TARGET_FILE}.cache ${TARGET_DIR}/${TARGET_FILE}.cache.org" );
		system( "/bin/mv  ${TARGET_DIR}/${TARGET_FILE}       ${TARGET_DIR}/${TARGET_FILE}.org" );
		system( "/bin/cat ${TARGET_DIR}/${TARGET_FILE}.org   ${TARGET_DIR}/${TARGET_FILE}.arib > ${TARGET_DIR}/${TARGET_FILE}" );
		system( "/usr/sbin/iconvconfig" );
		print "created new gconv cache. finished.\n";
	}
	else
	{
		print "gconv ARIB STD-B24 is already intstalled. aborted.\n";
	}
}
else
{
	die( "aborted by user.\n" );
}
exit(0);
